// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

using System;
using System.Net.Sockets;
using System.Runtime.InteropServices;

internal static partial class Interop
{
    internal static partial class Sys
    {
        [LibraryImport(Libraries.SystemNative, EntryPoint = "SystemNative_Bind")]
        private static partial Error Bind(SafeHandle socket, ProtocolType socketProtocolType, ReadOnlySpan<byte> socketAddress, int socketAddressLen);

        internal static Error Bind(
            SafeHandle socket, ProtocolType socketProtocolType, ReadOnlySpan<byte> socketAddress)
            => Bind(socket, socketProtocolType, socketAddress, socketAddress.Length);
    }
}
