// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.
// ------------------------------------------------------------------------------
// Changes to this file must follow the https://aka.ms/api-review process.
// ------------------------------------------------------------------------------

namespace System.ComponentModel
{
    public partial class AsyncCompletedEventArgs : System.EventArgs
    {
        public AsyncCompletedEventArgs(System.Exception? error, bool cancelled, object? userState) { }
        public bool Cancelled { get { throw null; } }
        public System.Exception? Error { get { throw null; } }
        public object? UserState { get { throw null; } }
        protected void RaiseExceptionIfNecessary() { }
    }
    public delegate void AsyncCompletedEventHandler(object? sender, System.ComponentModel.AsyncCompletedEventArgs e);
    public sealed partial class AsyncOperation
    {
        internal AsyncOperation() { }
        public System.Threading.SynchronizationContext SynchronizationContext { get { throw null; } }
        public object? UserSuppliedState { get { throw null; } }
        ~AsyncOperation() { }
        public void OperationCompleted() { }
        public void Post(System.Threading.SendOrPostCallback d, object? arg) { }
        public void PostOperationCompleted(System.Threading.SendOrPostCallback d, object? arg) { }
    }
    public static partial class AsyncOperationManager
    {
        [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
        public static System.Threading.SynchronizationContext SynchronizationContext { get { throw null; } set { } }
        public static System.ComponentModel.AsyncOperation CreateOperation(object? userSuppliedState) { throw null; }
    }
    public partial class BackgroundWorker : System.ComponentModel.Component
    {
        public BackgroundWorker() { }
        public bool CancellationPending { get { throw null; } }
        public bool IsBusy { get { throw null; } }
        public bool WorkerReportsProgress { get { throw null; } set { } }
        public bool WorkerSupportsCancellation { get { throw null; } set { } }
        public event System.ComponentModel.DoWorkEventHandler? DoWork { add { } remove { } }
        public event System.ComponentModel.ProgressChangedEventHandler? ProgressChanged { add { } remove { } }
        public event System.ComponentModel.RunWorkerCompletedEventHandler? RunWorkerCompleted { add { } remove { } }
        public void CancelAsync() { }
        protected override void Dispose(bool disposing) { }
        protected virtual void OnDoWork(System.ComponentModel.DoWorkEventArgs e) { }
        protected virtual void OnProgressChanged(System.ComponentModel.ProgressChangedEventArgs e) { }
        protected virtual void OnRunWorkerCompleted(System.ComponentModel.RunWorkerCompletedEventArgs e) { }
        public void ReportProgress(int percentProgress) { }
        public void ReportProgress(int percentProgress, object? userState) { }
        public void RunWorkerAsync() { }
        public void RunWorkerAsync(object? argument) { }
    }
    public partial class DoWorkEventArgs : System.ComponentModel.CancelEventArgs
    {
        public DoWorkEventArgs(object? argument) { }
        public object? Argument { get { throw null; } }
        public object? Result { get { throw null; } set { } }
    }
    public delegate void DoWorkEventHandler(object? sender, System.ComponentModel.DoWorkEventArgs e);
    public partial class ProgressChangedEventArgs : System.EventArgs
    {
        public ProgressChangedEventArgs(int progressPercentage, object? userState) { }
        public int ProgressPercentage { get { throw null; } }
        public object? UserState { get { throw null; } }
    }
    public delegate void ProgressChangedEventHandler(object? sender, System.ComponentModel.ProgressChangedEventArgs e);
    public partial class RunWorkerCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs
    {
        public RunWorkerCompletedEventArgs(object? result, System.Exception? error, bool cancelled) : base (default(System.Exception), default(bool), default(object)) { }
        public object? Result { get { throw null; } }
        [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Never)]
        public new object? UserState { get { throw null; } }
    }
    public delegate void RunWorkerCompletedEventHandler(object? sender, System.ComponentModel.RunWorkerCompletedEventArgs e);
}
