// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

namespace System.Net
{
    /// <devdoc>
    ///    <para>
    ///       Holds the interface for implementation of the proxy interface.
    ///       Used to implement and control proxy use of WebRequests.
    ///    </para>
    /// </devdoc>
    public interface IWebProxy
    {
        Uri? GetProxy(Uri destination);
        bool IsBypassed(Uri host);
        ICredentials? Credentials { get; set; }
    }
}
