// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

using OLEDB.Test.ModuleCore;

namespace System.Xml.XmlConvertTests
{
    internal abstract class XmlBaseCharConvertTests : CTestCase
    {
        #region Static Fields

        public static string[] _Expbyte_BaseChar = { "_x0040_", "_x005B_", "_x0060_", "_x007B_", "_x00BF_", "_x00D7_", "_x00F7_", "_x0132_", "_x0133_", "_x013F_", "_x0140_", "_x0149_", "_x017F_", "_x01C4_", "_x01CC_", "_x01F1_", "_x01F3_", "_x01F6_", "_x01F9_", "_x0218_", "_x024F_", "_x02A9_", "_x02BA_", "_x02C2_", "_x0385_", "_x0387_", "_x038B_", "_x038D_", "_x03A2_", "_x03CF_", "_x03D7_", "_x03D9_", "_x03DB_", "_x03DD_", "_x03DF_", "_x03E1_", "_x03F4_", "_x0400_", "_x040D_", "_x0450_", "_x045D_", "_x0482_", "_x048F_", "_x04C5_", "_x04C6_", "_x04C9_", "_x04CA_", "_x04CD_", "_x04CF_", "_x04EC_", "_x04ED_", "_x04F6_", "_x04F7_", "_x04FA_", "_x0530_", "_x0557_", "_x0558_", "_x055A_", "_x0560_", "_x0587_", "_x05CF_", "_x05EB_", "_x05EF_", "_x05F3_", "_x0620_", "_x063B_", "_x0640_", "_x064B_", "_x0670_", "_x06B8_", "_x06B9_", "_x06BF_", "_x06CF_", "_x06D4_", "_x06D6_", "_x06E4_", "_x06E7_", "_x0904_", "_x093A_", "_x093C_", "_x093E_", "_x0957_", "_x0962_", "_x0984_", "_x098D_", "_x098E_", "_x0991_", "_x0992_", "_x09A9_", "_x09B1_", "_x09B3_", "_x09B5_", "_x09BA_", "_x09DB_", "_x09DE_", "_x09E2_", "_x09EF_", "_x09F2_", "_x0A04_", "_x0A0B_", "_x0A0E_", "_x0A11_", "_x0A12_", "_x0A29_", "_x0A31_", "_x0A34_", "_x0A37_", "_x0A3A_", "_x0A58_", "_x0A5D_", "_x0A5F_", "_x0A71_", "_x0A75_", "_x0A84_", "_x0A8C_", "_x0A8E_", "_x0A92_", "_x0AA9_", "_x0AB1_", "_x0AB4_", "_x0ABA_", "_x0ABC_", "_x0ABE_", "_x0ADF_", "_x0AE1_", "_x0B04_", "_x0B0D_", "_x0B0E_", "_x0B11_", "_x0B12_", "_x0B29_", "_x0B31_", "_x0B34_", "_x0B35_", "_x0B3A_", "_x0B3C_", "_x0B3E_", "_x0B5B_", "_x0B5E_", "_x0B62_", "_x0B84_", "_x0B8B_", "_x0B8D_", "_x0B91_", "_x0B96_", "_x0B98_", "_x0B9B_", "_x0B9D_", "_x0BA0_", "_x0BA2_", "_x0BA5_", "_x0BA7_", "_x0BAB_", "_x0BAD_", "_x0BB6_", "_x0BBA_", "_x0C04_", "_x0C0D_", "_x0C11_", "_x0C29_", "_x0C34_", "_x0C3A_", "_x0C5F_", "_x0C62_", "_x0C84_", "_x0C8D_", "_x0C91_", "_x0CA9_", "_x0CB4_", "_x0CBA_", "_x0CDD_", "_x0CDF_", "_x0CE2_", "_x0D04_", "_x0D0D_", "_x0D11_", "_x0D29_", "_x0D3A_", "_x0D5F_", "_x0D62_", "_x0E00_", "_x0E2F_", "_x0E31_", "_x0E34_", "_x0E3F_", "_x0E46_", "_x0E80_", "_x0E83_", "_x0E85_", "_x0E86_", "_x0E89_", "_x0E8B_", "_x0E8C_", "_x0E8E_", "_x0E93_", "_x0E98_", "_x0EA0_", "_x0EA4_", "_x0EA6_", "_x0EA8_", "_x0EA9_", "_x0EAC_", "_x0EAF_", "_x0EB1_", "_x0EB4_", "_x0EBC_", "_x0EBE_", "_x0EBF_", "_x0EC5_", "_x0F3F_", "_x0F48_", "_x0F6A_", "_x109F_", "_x10C6_", "_x10CF_", "_x10F7_", "_x10FF_", "_x1101_", "_x1104_", "_x1108_", "_x110A_", "_x110D_", "_x1113_", "_x113B_", "_x113D_", "_x113F_", "_x1141_", "_x114B_", "_x114D_", "_x114F_", "_x1151_", "_x1153_", "_x1156_", "_x1158_", "_x115A_", "_x115E_", "_x1162_", "_x1164_", "_x1166_", "_x1168_", "_x116A_", "_x116C_", "_x116F_", "_x1171_", "_x1174_", "_x1176_", "_x119D_", "_x119F_", "_x11A7_", "_x11A9_", "_x11AA_", "_x11AC_", "_x11AD_", "_x11B0_", "_x11B6_", "_x11B9_", "_x11BB_", "_x11C3_", "_x11EA_", "_x11EC_", "_x11EF_", "_x11F1_", "_x11F8_", "_x11FA_", "_x1DFF_", "_x1E9C_", "_x1E9F_", "_x1EFA_", "_x1EFF_", "_x1F16_", "_x1F17_", "_x1F1E_", "_x1F1F_", "_x1F46_", "_x1F47_", "_x1F4E_", "_x1F4F_", "_x1F58_", "_x1F5A_", "_x1F5C_", "_x1F5E_", "_x1F7E_", "_x1F7F_", "_x1FB5_", "_x1FBD_", "_x1FBF_", "_x1FC1_", "_x1FC5_", "_x1FCD_", "_x1FCF_", "_x1FD4_", "_x1FD5_", "_x1FDC_", "_x1FDF_", "_x1FED_", "_x1FF1_", "_x1FF5_", "_x1FFD_", "_x2125_", "_x2127_", "_x2129_", "_x212C_", "_x212D_", "_x212F_", "_x217F_", "_x2183_", "_x3040_", "_x3095_", "_x30A0_", "_x30FB_", "_x3104_", "_x312D_", "_xABFF_", "_xD7A4_" };

        public static byte[] _byte_BaseChar = { 0x40, 0x00, 0x5B, 0x00, 0x60, 0x00, 0x7B, 0x00, 0xBf, 0x00, 0xD7, 0x00, 0xF7, 0x00, 0x32, 0x01, 0x33, 0x01, 0x3F, 0x01, 0x40, 0x01, 0x49, 0x01, 0x7F, 0x01, 0xC4, 0x01, 0xCC, 0x01, 0xF1, 0x01, 0xF3, 0x01, 0xF6, 0x01, 0xF9, 0x01, 0x18, 0x02, 0x4F, 0x02, 0xA9, 0x02, 0xbA, 0x02, 0xC2, 0x02, 0x85, 0x03, 0x87, 0x03, 0x8b, 0x03, 0x8D, 0x03, 0xA2, 0x03, 0xCF, 0x03, 0xD7, 0x03, 0xD9, 0x03, 0xDb, 0x03, 0xDD, 0x03, 0xDF, 0x03, 0xE1, 0x03, 0xF4, 0x03, 0x00, 0x04, 0x0D, 0x04, 0x50, 0x04, 0x5D, 0x04, 0x82, 0x04, 0x8F, 0x04, 0xC5, 0x04, 0xC6, 0x04, 0xC9, 0x04, 0xCA, 0x04, 0xCD, 0x04, 0xCF, 0x04, 0xEC, 0x04, 0xED, 0x04, 0xF6, 0x04, 0xF7, 0x04, 0xFA, 0x04, 0x30, 0x05, 0x57, 0x05, 0x58, 0x05, 0x5A, 0x05, 0x60, 0x05, 0x87, 0x05, 0xCF, 0x05, 0xEb, 0x05, 0xEF, 0x05, 0xF3, 0x05, 0x20, 0x06, 0x3b, 0x06, 0x40, 0x06, 0x4b, 0x06, 0x70, 0x06, 0xb8, 0x06, 0xb9, 0x06, 0xbF, 0x06, 0xCF, 0x06, 0xD4, 0x06, 0xD6, 0x06, 0xE4, 0x06, 0xE7, 0x06, 0x04, 0x09, 0x3A, 0x09, 0x3C, 0x09, 0x3E, 0x09, 0x57, 0x09, 0x62, 0x09, 0x84, 0x09, 0x8D, 0x09, 0x8E, 0x09, 0x91, 0x09, 0x92, 0x09, 0xA9, 0x09, 0xb1, 0x09, 0xb3, 0x09, 0xb5, 0x09, 0xbA, 0x09, 0xDb, 0x09, 0xDE, 0x09, 0xE2, 0x09, 0xEF, 0x09, 0xF2, 0x09, 0x04, 0x0A, 0x0b, 0x0A, 0x0E, 0x0A, 0x11, 0x0A, 0x12, 0x0A, 0x29, 0x0A, 0x31, 0x0A, 0x34, 0x0A, 0x37, 0x0A, 0x3A, 0x0A, 0x58, 0x0A, 0x5D, 0x0A, 0x5F, 0x0A, 0x71, 0x0A, 0x75, 0x0A, 0x84, 0x0A, 0x8C, 0x0A, 0x8E, 0x0A, 0x92, 0x0A, 0xA9, 0x0A, 0xb1, 0x0A, 0xb4, 0x0A, 0xbA, 0x0A, 0xbC, 0x0A, 0xbE, 0x0A, 0xDF, 0x0A, 0xE1, 0x0A, 0x04, 0x0b, 0x0D, 0x0b, 0x0E, 0x0B, 0x11, 0x0B, 0x12, 0x0B, 0x29, 0x0B, 0x31, 0x0B, 0x34, 0x0B, 0x35, 0x0B, 0x3A, 0x0B, 0x3C, 0x0B, 0x3E, 0x0B, 0x5B, 0x0B, 0x5E, 0x0B, 0x62, 0x0B, 0x84, 0x0B, 0x8B, 0x0B, 0x8D, 0x0B, 0x91, 0x0B, 0x96, 0x0B, 0x98, 0x0B, 0x9B, 0x0B, 0x9D, 0x0B, 0xA0, 0x0B, 0xA2, 0x0B, 0xA5, 0x0B, 0xA7, 0x0B, 0xAB, 0x0B, 0xAD, 0x0B, 0xB6, 0x0B, 0xBA, 0x0B, 0x04, 0x0C, 0x0D, 0x0C, 0x11, 0x0C, 0x29, 0x0C, 0x34, 0x0C, 0x3A, 0x0C, 0x5F, 0x0C, 0x62, 0x0C, 0x84, 0x0C, 0x8D, 0x0C, 0x91, 0x0C, 0xA9, 0x0C, 0xB4, 0x0C, 0xBA, 0x0C, 0xDD, 0x0C, 0xDF, 0x0C, 0xE2, 0x0C, 0x04, 0x0D, 0x0D, 0x0D, 0x11, 0x0D, 0x29, 0x0D, 0x3A, 0x0D, 0x5F, 0x0D, 0x62, 0x0D, 0x00, 0x0E, 0x2F, 0x0E, 0x31, 0x0E, 0x34, 0x0E, 0x3F, 0x0E, 0x46, 0x0E, 0x80, 0x0E, 0x83, 0x0E, 0x85, 0x0E, 0x86, 0x0E, 0x89, 0x0E, 0x8B, 0x0E, 0x8C, 0x0E, 0x8E, 0x0E, 0x93, 0x0E, 0x98, 0x0E, 0xA0, 0x0E, 0xA4, 0x0E, 0xA6, 0x0E, 0xA8, 0x0E, 0xA9, 0x0E, 0xAC, 0x0E, 0xAF, 0x0E, 0xB1, 0x0E, 0xB4, 0x0E, 0xBC, 0x0E, 0xBE, 0x0E, 0xBF, 0x0E, 0xC5, 0x0E, 0x3F, 0x0F, 0x48, 0x0F, 0x6A, 0x0F, 0x9F, 0x10, 0xC6, 0x10, 0xCF, 0x10, 0xF7, 0x10, 0xFF, 0x10, 0x01, 0x11, 0x04, 0x11, 0x08, 0x11, 0x0A, 0x11, 0x0D, 0x11, 0x13, 0x11, 0x3B, 0x11, 0x3D, 0x11, 0x3F, 0x11, 0x41, 0x11, 0x4B, 0x11, 0x4D, 0x11, 0x4F, 0x11, 0x51, 0x11, 0x53, 0x11, 0x56, 0x11, 0x58, 0x11, 0x5A, 0x11, 0x5E, 0x11, 0x62, 0x11, 0x64, 0x11, 0x66, 0x11, 0x68, 0x11, 0x6A, 0x11, 0x6C, 0x11, 0x6F, 0x11, 0x71, 0x11, 0x74, 0x11, 0x76, 0x11, 0x9D, 0x11, 0x9F, 0x11, 0xA7, 0x11, 0xA9, 0x11, 0xAA, 0x11, 0xAC, 0x11, 0xAD, 0x11, 0xB0, 0x11, 0xB6, 0x11, 0xB9, 0x11, 0xBB, 0x11, 0xC3, 0x11, 0xEA, 0x11, 0xEC, 0x11, 0xEF, 0x11, 0xF1, 0x11, 0xF8, 0x11, 0xFA, 0x11, 0xFF, 0x1D, 0x9C, 0x1E, 0x9F, 0x1E, 0xFA, 0x1E, 0xFF, 0x1E, 0x16, 0x1F, 0x17, 0x1F, 0x1E, 0x1F, 0x1F, 0x1F, 0x46, 0x1F, 0x47, 0x1F, 0x4E, 0x1F, 0x4F, 0x1F, 0x58, 0x1F, 0x5A, 0x1F, 0x5C, 0x1F, 0x5E, 0x1F, 0x7E, 0x1F, 0x7F, 0x1F, 0xB5, 0x1F, 0xBD, 0x1F, 0xBF, 0x1F, 0xC1, 0x1F, 0xC5, 0x1F, 0xCD, 0x1F, 0xCF, 0x1F, 0xD4, 0x1F, 0xD5, 0x1F, 0xDC, 0x1F, 0xDF, 0x1F, 0xED, 0x1F, 0xF1, 0x1F, 0xF5, 0x1F, 0xFD, 0x1F, 0x25, 0x21, 0x27, 0x21, 0x29, 0x21, 0x2C, 0x21, 0x2D, 0x21, 0x2F, 0x21, 0x7F, 0x21, 0x83, 0x21, 0x40, 0x30, 0x95, 0x30, 0xA0, 0x30, 0xFB, 0x30, 0x04, 0x31, 0x2D, 0x31, 0xFF, 0xAB, 0xA4, 0xD7 };

        #endregion

        #region Public Methods and Operators

        public override int Init(object objParam)
        {
            return TEST_PASS;
        }
        #endregion
    }
}
