# System.Text.RegularExpressions
This assembly provides regular expression functionality. The main type contained in the assembly is [Regex](https://learn.microsoft.com/en-us/dotnet/api/system.text.regularexpressions.regex) class, which represents an immutable regular expression object which can be used to test for matches on given input strings or spans.

Documentation can be found at https://learn.microsoft.com/dotnet/api/system.text.regularexpressions.

## Contribution Bar
- [x] [We consider new features, new APIs and performance changes](../../libraries/README.md#primary-bar)
- [x] [We consider PRs that target this library for new source code analyzers](../../libraries/README.md#secondary-bars)

Recent improvements to the library are detailed at:
- [Regex Performance Improvements in .NET 5](https://devblogs.microsoft.com/dotnet/regex-performance-improvements-in-net-5/)
- [Regular Expression Improvements in .NET 7](https://devblogs.microsoft.com/dotnet/regular-expression-improvements-in-dotnet-7/)

We plan on continuing to focus on performance as well as to add new APIs and features to the engines.

See the [Help Wanted](https://github.com/dotnet/runtime/issues?q=is%3Aissue+is%3Aopen+label%3A%22help+wanted%22+label%3Aarea-System.Text.RegularExpressions) issues.

## Deployment
System.Text.RegularExpressions assembly is part of the shared framework, and ships with every new release of .NET.
