// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

using System;
using System.Linq;
using System.Reflection;
using System.Runtime.CompilerServices;
using Xunit;

public class Program
{
    private static int returnCode = 100;

    [Fact]
    public static int TestEntryPoint()
    {
        int[] testIndices = Enumerable.Range(-50, 50)
                // also add some corner case values
                .Concat(new[] { int.MinValue, int.MinValue + 1, int.MaxValue, int.MaxValue - 1 })
                .ToArray();

        foreach (int index in testIndices)
        {
            CompareActions(index, Tests.Test000_cns, Tests.Test000_var);
            CompareActions(index, Tests.Test001_cns, Tests.Test001_var);
            CompareActions(index, Tests.Test002_cns, Tests.Test002_var);
            CompareActions(index, Tests.Test003_cns, Tests.Test003_var);
            CompareActions(index, Tests.Test004_cns, Tests.Test004_var);
            CompareActions(index, Tests.Test005_cns, Tests.Test005_var);
            CompareActions(index, Tests.Test006_cns, Tests.Test006_var);
            CompareActions(index, Tests.Test007_cns, Tests.Test007_var);
            CompareActions(index, Tests.Test008_cns, Tests.Test008_var);
            CompareActions(index, Tests.Test009_cns, Tests.Test009_var);
            CompareActions(index, Tests.Test010_cns, Tests.Test010_var);
            CompareActions(index, Tests.Test011_cns, Tests.Test011_var);
            CompareActions(index, Tests.Test012_cns, Tests.Test012_var);
            CompareActions(index, Tests.Test013_cns, Tests.Test013_var);
            CompareActions(index, Tests.Test014_cns, Tests.Test014_var);
            CompareActions(index, Tests.Test015_cns, Tests.Test015_var);
            CompareActions(index, Tests.Test016_cns, Tests.Test016_var);
            CompareActions(index, Tests.Test017_cns, Tests.Test017_var);
            CompareActions(index, Tests.Test018_cns, Tests.Test018_var);
            CompareActions(index, Tests.Test019_cns, Tests.Test019_var);
            CompareActions(index, Tests.Test020_cns, Tests.Test020_var);
            CompareActions(index, Tests.Test021_cns, Tests.Test021_var);
            CompareActions(index, Tests.Test022_cns, Tests.Test022_var);
            CompareActions(index, Tests.Test023_cns, Tests.Test023_var);
            CompareActions(index, Tests.Test024_cns, Tests.Test024_var);
            CompareActions(index, Tests.Test025_cns, Tests.Test025_var);
            CompareActions(index, Tests.Test026_cns, Tests.Test026_var);
            CompareActions(index, Tests.Test027_cns, Tests.Test027_var);
            CompareActions(index, Tests.Test028_cns, Tests.Test028_var);
            CompareActions(index, Tests.Test029_cns, Tests.Test029_var);
            CompareActions(index, Tests.Test030_cns, Tests.Test030_var);
            CompareActions(index, Tests.Test031_cns, Tests.Test031_var);
            CompareActions(index, Tests.Test032_cns, Tests.Test032_var);
            CompareActions(index, Tests.Test033_cns, Tests.Test033_var);
            CompareActions(index, Tests.Test034_cns, Tests.Test034_var);
            CompareActions(index, Tests.Test035_cns, Tests.Test035_var);
            CompareActions(index, Tests.Test036_cns, Tests.Test036_var);
            CompareActions(index, Tests.Test037_cns, Tests.Test037_var);
            CompareActions(index, Tests.Test038_cns, Tests.Test038_var);
            CompareActions(index, Tests.Test039_cns, Tests.Test039_var);
            CompareActions(index, Tests.Test040_cns, Tests.Test040_var);
            CompareActions(index, Tests.Test041_cns, Tests.Test041_var);
            CompareActions(index, Tests.Test042_cns, Tests.Test042_var);
            CompareActions(index, Tests.Test043_cns, Tests.Test043_var);
            CompareActions(index, Tests.Test044_cns, Tests.Test044_var);
            CompareActions(index, Tests.Test045_cns, Tests.Test045_var);
            CompareActions(index, Tests.Test046_cns, Tests.Test046_var);
            CompareActions(index, Tests.Test047_cns, Tests.Test047_var);
            CompareActions(index, Tests.Test048_cns, Tests.Test048_var);
            CompareActions(index, Tests.Test049_cns, Tests.Test049_var);
            CompareActions(index, Tests.Test050_cns, Tests.Test050_var);
            CompareActions(index, Tests.Test051_cns, Tests.Test051_var);
            CompareActions(index, Tests.Test052_cns, Tests.Test052_var);
            CompareActions(index, Tests.Test053_cns, Tests.Test053_var);
            CompareActions(index, Tests.Test054_cns, Tests.Test054_var);
            CompareActions(index, Tests.Test055_cns, Tests.Test055_var);
            CompareActions(index, Tests.Test056_cns, Tests.Test056_var);
            CompareActions(index, Tests.Test057_cns, Tests.Test057_var);
            CompareActions(index, Tests.Test058_cns, Tests.Test058_var);
            CompareActions(index, Tests.Test059_cns, Tests.Test059_var);
            CompareActions(index, Tests.Test060_cns, Tests.Test060_var);
            CompareActions(index, Tests.Test061_cns, Tests.Test061_var);
            CompareActions(index, Tests.Test062_cns, Tests.Test062_var);
            CompareActions(index, Tests.Test063_cns, Tests.Test063_var);
            CompareActions(index, Tests.Test064_cns, Tests.Test064_var);
            CompareActions(index, Tests.Test065_cns, Tests.Test065_var);
            CompareActions(index, Tests.Test066_cns, Tests.Test066_var);
            CompareActions(index, Tests.Test067_cns, Tests.Test067_var);
            CompareActions(index, Tests.Test068_cns, Tests.Test068_var);
            CompareActions(index, Tests.Test069_cns, Tests.Test069_var);
            CompareActions(index, Tests.Test070_cns, Tests.Test070_var);
            CompareActions(index, Tests.Test071_cns, Tests.Test071_var);
            CompareActions(index, Tests.Test072_cns, Tests.Test072_var);
            CompareActions(index, Tests.Test073_cns, Tests.Test073_var);
            CompareActions(index, Tests.Test074_cns, Tests.Test074_var);
            CompareActions(index, Tests.Test075_cns, Tests.Test075_var);
            CompareActions(index, Tests.Test076_cns, Tests.Test076_var);
            CompareActions(index, Tests.Test077_cns, Tests.Test077_var);
            CompareActions(index, Tests.Test078_cns, Tests.Test078_var);
            CompareActions(index, Tests.Test079_cns, Tests.Test079_var);
            CompareActions(index, Tests.Test080_cns, Tests.Test080_var);
            CompareActions(index, Tests.Test081_cns, Tests.Test081_var);
            CompareActions(index, Tests.Test082_cns, Tests.Test082_var);
            CompareActions(index, Tests.Test083_cns, Tests.Test083_var);
            CompareActions(index, Tests.Test084_cns, Tests.Test084_var);
            CompareActions(index, Tests.Test085_cns, Tests.Test085_var);
            CompareActions(index, Tests.Test086_cns, Tests.Test086_var);
            CompareActions(index, Tests.Test087_cns, Tests.Test087_var);
            CompareActions(index, Tests.Test088_cns, Tests.Test088_var);
            CompareActions(index, Tests.Test089_cns, Tests.Test089_var);
            CompareActions(index, Tests.Test090_cns, Tests.Test090_var);
            CompareActions(index, Tests.Test091_cns, Tests.Test091_var);
            CompareActions(index, Tests.Test092_cns, Tests.Test092_var);
            CompareActions(index, Tests.Test093_cns, Tests.Test093_var);
            CompareActions(index, Tests.Test094_cns, Tests.Test094_var);
            CompareActions(index, Tests.Test095_cns, Tests.Test095_var);
            CompareActions(index, Tests.Test096_cns, Tests.Test096_var);
            CompareActions(index, Tests.Test097_cns, Tests.Test097_var);
            CompareActions(index, Tests.Test098_cns, Tests.Test098_var);
            CompareActions(index, Tests.Test099_cns, Tests.Test099_var);
            CompareActions(index, Tests.Test100_cns, Tests.Test100_var);
            CompareActions(index, Tests.Test101_cns, Tests.Test101_var);
            CompareActions(index, Tests.Test102_cns, Tests.Test102_var);
            CompareActions(index, Tests.Test103_cns, Tests.Test103_var);
            CompareActions(index, Tests.Test104_cns, Tests.Test104_var);
            CompareActions(index, Tests.Test105_cns, Tests.Test105_var);
            CompareActions(index, Tests.Test106_cns, Tests.Test106_var);
            CompareActions(index, Tests.Test107_cns, Tests.Test107_var);
            CompareActions(index, Tests.Test108_cns, Tests.Test108_var);
            CompareActions(index, Tests.Test109_cns, Tests.Test109_var);
            CompareActions(index, Tests.Test110_cns, Tests.Test110_var);
            CompareActions(index, Tests.Test111_cns, Tests.Test111_var);
            CompareActions(index, Tests.Test112_cns, Tests.Test112_var);
            CompareActions(index, Tests.Test113_cns, Tests.Test113_var);
            CompareActions(index, Tests.Test114_cns, Tests.Test114_var);
            CompareActions(index, Tests.Test115_cns, Tests.Test115_var);
            CompareActions(index, Tests.Test116_cns, Tests.Test116_var);
            CompareActions(index, Tests.Test117_cns, Tests.Test117_var);
            CompareActions(index, Tests.Test118_cns, Tests.Test118_var);
            CompareActions(index, Tests.Test119_cns, Tests.Test119_var);
            CompareActions(index, Tests.Test120_cns, Tests.Test120_var);
            CompareActions(index, Tests.Test121_cns, Tests.Test121_var);
            CompareActions(index, Tests.Test122_cns, Tests.Test122_var);
            CompareActions(index, Tests.Test123_cns, Tests.Test123_var);
            CompareActions(index, Tests.Test124_cns, Tests.Test124_var);
            CompareActions(index, Tests.Test125_cns, Tests.Test125_var);
            CompareActions(index, Tests.Test126_cns, Tests.Test126_var);
            CompareActions(index, Tests.Test127_cns, Tests.Test127_var);
            CompareActions(index, Tests.Test128_cns, Tests.Test128_var);
            CompareActions(index, Tests.Test129_cns, Tests.Test129_var);
            CompareActions(index, Tests.Test130_cns, Tests.Test130_var);
            CompareActions(index, Tests.Test131_cns, Tests.Test131_var);
            CompareActions(index, Tests.Test132_cns, Tests.Test132_var);
            CompareActions(index, Tests.Test133_cns, Tests.Test133_var);
            CompareActions(index, Tests.Test134_cns, Tests.Test134_var);
            CompareActions(index, Tests.Test135_cns, Tests.Test135_var);
            CompareActions(index, Tests.Test136_cns, Tests.Test136_var);
            CompareActions(index, Tests.Test137_cns, Tests.Test137_var);
            CompareActions(index, Tests.Test138_cns, Tests.Test138_var);
            CompareActions(index, Tests.Test139_cns, Tests.Test139_var);
            CompareActions(index, Tests.Test140_cns, Tests.Test140_var);
            CompareActions(index, Tests.Test141_cns, Tests.Test141_var);
            CompareActions(index, Tests.Test142_cns, Tests.Test142_var);
            CompareActions(index, Tests.Test143_cns, Tests.Test143_var);
            CompareActions(index, Tests.Test144_cns, Tests.Test144_var);
            CompareActions(index, Tests.Test145_cns, Tests.Test145_var);
            CompareActions(index, Tests.Test146_cns, Tests.Test146_var);
            CompareActions(index, Tests.Test147_cns, Tests.Test147_var);
            CompareActions(index, Tests.Test148_cns, Tests.Test148_var);
            CompareActions(index, Tests.Test149_cns, Tests.Test149_var);
            CompareActions(index, Tests.Test150_cns, Tests.Test150_var);
            CompareActions(index, Tests.Test151_cns, Tests.Test151_var);
            CompareActions(index, Tests.Test152_cns, Tests.Test152_var);
            CompareActions(index, Tests.Test153_cns, Tests.Test153_var);
            CompareActions(index, Tests.Test154_cns, Tests.Test154_var);
            CompareActions(index, Tests.Test155_cns, Tests.Test155_var);
            CompareActions(index, Tests.Test156_cns, Tests.Test156_var);
            CompareActions(index, Tests.Test157_cns, Tests.Test157_var);
            CompareActions(index, Tests.Test158_cns, Tests.Test158_var);
            CompareActions(index, Tests.Test159_cns, Tests.Test159_var);
            CompareActions(index, Tests.Test160_cns, Tests.Test160_var);
            CompareActions(index, Tests.Test161_cns, Tests.Test161_var);
            CompareActions(index, Tests.Test162_cns, Tests.Test162_var);
            CompareActions(index, Tests.Test163_cns, Tests.Test163_var);
            CompareActions(index, Tests.Test164_cns, Tests.Test164_var);
            CompareActions(index, Tests.Test165_cns, Tests.Test165_var);
            CompareActions(index, Tests.Test166_cns, Tests.Test166_var);
            CompareActions(index, Tests.Test167_cns, Tests.Test167_var);
            CompareActions(index, Tests.Test168_cns, Tests.Test168_var);
            CompareActions(index, Tests.Test169_cns, Tests.Test169_var);
            CompareActions(index, Tests.Test170_cns, Tests.Test170_var);
            CompareActions(index, Tests.Test171_cns, Tests.Test171_var);
            CompareActions(index, Tests.Test172_cns, Tests.Test172_var);
            CompareActions(index, Tests.Test173_cns, Tests.Test173_var);
            CompareActions(index, Tests.Test174_cns, Tests.Test174_var);
            CompareActions(index, Tests.Test175_cns, Tests.Test175_var);
            CompareActions(index, Tests.Test176_cns, Tests.Test176_var);
            CompareActions(index, Tests.Test177_cns, Tests.Test177_var);
            CompareActions(index, Tests.Test178_cns, Tests.Test178_var);
            CompareActions(index, Tests.Test179_cns, Tests.Test179_var);
            CompareActions(index, Tests.Test180_cns, Tests.Test180_var);
            CompareActions(index, Tests.Test181_cns, Tests.Test181_var);
            CompareActions(index, Tests.Test182_cns, Tests.Test182_var);
            CompareActions(index, Tests.Test183_cns, Tests.Test183_var);
            CompareActions(index, Tests.Test184_cns, Tests.Test184_var);
            CompareActions(index, Tests.Test185_cns, Tests.Test185_var);
            CompareActions(index, Tests.Test186_cns, Tests.Test186_var);
            CompareActions(index, Tests.Test187_cns, Tests.Test187_var);
            CompareActions(index, Tests.Test188_cns, Tests.Test188_var);
            CompareActions(index, Tests.Test189_cns, Tests.Test189_var);
            CompareActions(index, Tests.Test190_cns, Tests.Test190_var);
            CompareActions(index, Tests.Test191_cns, Tests.Test191_var);
            CompareActions(index, Tests.Test192_cns, Tests.Test192_var);
            CompareActions(index, Tests.Test193_cns, Tests.Test193_var);
            CompareActions(index, Tests.Test194_cns, Tests.Test194_var);
            CompareActions(index, Tests.Test195_cns, Tests.Test195_var);
            CompareActions(index, Tests.Test196_cns, Tests.Test196_var);
            CompareActions(index, Tests.Test197_cns, Tests.Test197_var);
            CompareActions(index, Tests.Test198_cns, Tests.Test198_var);
            CompareActions(index, Tests.Test199_cns, Tests.Test199_var);
            CompareActions(index, Tests.Test200_cns, Tests.Test200_var);
            CompareActions(index, Tests.Test201_cns, Tests.Test201_var);
            CompareActions(index, Tests.Test202_cns, Tests.Test202_var);
            CompareActions(index, Tests.Test203_cns, Tests.Test203_var);
            CompareActions(index, Tests.Test204_cns, Tests.Test204_var);
            CompareActions(index, Tests.Test205_cns, Tests.Test205_var);
            CompareActions(index, Tests.Test206_cns, Tests.Test206_var);
            CompareActions(index, Tests.Test207_cns, Tests.Test207_var);
            CompareActions(index, Tests.Test208_cns, Tests.Test208_var);
            CompareActions(index, Tests.Test209_cns, Tests.Test209_var);
            CompareActions(index, Tests.Test210_cns, Tests.Test210_var);
            CompareActions(index, Tests.Test211_cns, Tests.Test211_var);
            CompareActions(index, Tests.Test212_cns, Tests.Test212_var);
            CompareActions(index, Tests.Test213_cns, Tests.Test213_var);
            CompareActions(index, Tests.Test214_cns, Tests.Test214_var);
            CompareActions(index, Tests.Test215_cns, Tests.Test215_var);
            CompareActions(index, Tests.Test216_cns, Tests.Test216_var);
            CompareActions(index, Tests.Test217_cns, Tests.Test217_var);
            CompareActions(index, Tests.Test218_cns, Tests.Test218_var);
            CompareActions(index, Tests.Test219_cns, Tests.Test219_var);
            CompareActions(index, Tests.Test220_cns, Tests.Test220_var);
            CompareActions(index, Tests.Test221_cns, Tests.Test221_var);
            CompareActions(index, Tests.Test222_cns, Tests.Test222_var);
            CompareActions(index, Tests.Test223_cns, Tests.Test223_var);
            CompareActions(index, Tests.Test224_cns, Tests.Test224_var);
            CompareActions(index, Tests.Test225_cns, Tests.Test225_var);
            CompareActions(index, Tests.Test226_cns, Tests.Test226_var);
            CompareActions(index, Tests.Test227_cns, Tests.Test227_var);
            CompareActions(index, Tests.Test228_cns, Tests.Test228_var);
            CompareActions(index, Tests.Test229_cns, Tests.Test229_var);
            CompareActions(index, Tests.Test230_cns, Tests.Test230_var);
            CompareActions(index, Tests.Test231_cns, Tests.Test231_var);
            CompareActions(index, Tests.Test232_cns, Tests.Test232_var);
            CompareActions(index, Tests.Test233_cns, Tests.Test233_var);
            CompareActions(index, Tests.Test234_cns, Tests.Test234_var);
            CompareActions(index, Tests.Test235_cns, Tests.Test235_var);
            CompareActions(index, Tests.Test236_cns, Tests.Test236_var);
            CompareActions(index, Tests.Test237_cns, Tests.Test237_var);
            CompareActions(index, Tests.Test238_cns, Tests.Test238_var);
            CompareActions(index, Tests.Test239_cns, Tests.Test239_var);
            CompareActions(index, Tests.Test240_cns, Tests.Test240_var);
            CompareActions(index, Tests.Test241_cns, Tests.Test241_var);
            CompareActions(index, Tests.Test242_cns, Tests.Test242_var);
            CompareActions(index, Tests.Test243_cns, Tests.Test243_var);
            CompareActions(index, Tests.Test244_cns, Tests.Test244_var);
            CompareActions(index, Tests.Test245_cns, Tests.Test245_var);
            CompareActions(index, Tests.Test246_cns, Tests.Test246_var);
            CompareActions(index, Tests.Test247_cns, Tests.Test247_var);
            CompareActions(index, Tests.Test248_cns, Tests.Test248_var);
            CompareActions(index, Tests.Test249_cns, Tests.Test249_var);
            CompareActions(index, Tests.Test250_cns, Tests.Test250_var);
            CompareActions(index, Tests.Test251_cns, Tests.Test251_var);
            CompareActions(index, Tests.Test252_cns, Tests.Test252_var);
            CompareActions(index, Tests.Test253_cns, Tests.Test253_var);
            CompareActions(index, Tests.Test254_cns, Tests.Test254_var);
            CompareActions(index, Tests.Test255_cns, Tests.Test255_var);
            CompareActions(index, Tests.Test256_cns, Tests.Test256_var);
            CompareActions(index, Tests.Test257_cns, Tests.Test257_var);
            CompareActions(index, Tests.Test258_cns, Tests.Test258_var);
            CompareActions(index, Tests.Test259_cns, Tests.Test259_var);
            CompareActions(index, Tests.Test260_cns, Tests.Test260_var);
            CompareActions(index, Tests.Test261_cns, Tests.Test261_var);
            CompareActions(index, Tests.Test262_cns, Tests.Test262_var);
            CompareActions(index, Tests.Test263_cns, Tests.Test263_var);
            CompareActions(index, Tests.Test264_cns, Tests.Test264_var);
            CompareActions(index, Tests.Test265_cns, Tests.Test265_var);
            CompareActions(index, Tests.Test266_cns, Tests.Test266_var);
            CompareActions(index, Tests.Test267_cns, Tests.Test267_var);
            CompareActions(index, Tests.Test268_cns, Tests.Test268_var);
            CompareActions(index, Tests.Test269_cns, Tests.Test269_var);
            CompareActions(index, Tests.Test270_cns, Tests.Test270_var);
            CompareActions(index, Tests.Test271_cns, Tests.Test271_var);
            CompareActions(index, Tests.Test272_cns, Tests.Test272_var);
            CompareActions(index, Tests.Test273_cns, Tests.Test273_var);
            CompareActions(index, Tests.Test274_cns, Tests.Test274_var);
            CompareActions(index, Tests.Test275_cns, Tests.Test275_var);
            CompareActions(index, Tests.Test276_cns, Tests.Test276_var);
            CompareActions(index, Tests.Test277_cns, Tests.Test277_var);
            CompareActions(index, Tests.Test278_cns, Tests.Test278_var);
            CompareActions(index, Tests.Test279_cns, Tests.Test279_var);
            CompareActions(index, Tests.Test280_cns, Tests.Test280_var);
            CompareActions(index, Tests.Test281_cns, Tests.Test281_var);
            CompareActions(index, Tests.Test282_cns, Tests.Test282_var);
            CompareActions(index, Tests.Test283_cns, Tests.Test283_var);
            CompareActions(index, Tests.Test284_cns, Tests.Test284_var);
            CompareActions(index, Tests.Test285_cns, Tests.Test285_var);
            CompareActions(index, Tests.Test286_cns, Tests.Test286_var);
            CompareActions(index, Tests.Test287_cns, Tests.Test287_var);
            CompareActions(index, Tests.Test288_cns, Tests.Test288_var);
            CompareActions(index, Tests.Test289_cns, Tests.Test289_var);
            CompareActions(index, Tests.Test290_cns, Tests.Test290_var);
            CompareActions(index, Tests.Test291_cns, Tests.Test291_var);
            CompareActions(index, Tests.Test292_cns, Tests.Test292_var);
            CompareActions(index, Tests.Test293_cns, Tests.Test293_var);
            CompareActions(index, Tests.Test294_cns, Tests.Test294_var);
            CompareActions(index, Tests.Test295_cns, Tests.Test295_var);
            CompareActions(index, Tests.Test296_cns, Tests.Test296_var);
            CompareActions(index, Tests.Test297_cns, Tests.Test297_var);
            CompareActions(index, Tests.Test298_cns, Tests.Test298_var);
            CompareActions(index, Tests.Test299_cns, Tests.Test299_var);
            CompareActions(index, Tests.Test300_cns, Tests.Test300_var);
            CompareActions(index, Tests.Test301_cns, Tests.Test301_var);
            CompareActions(index, Tests.Test302_cns, Tests.Test302_var);
            CompareActions(index, Tests.Test303_cns, Tests.Test303_var);
            CompareActions(index, Tests.Test304_cns, Tests.Test304_var);
            CompareActions(index, Tests.Test305_cns, Tests.Test305_var);
            CompareActions(index, Tests.Test306_cns, Tests.Test306_var);
            CompareActions(index, Tests.Test307_cns, Tests.Test307_var);
            CompareActions(index, Tests.Test308_cns, Tests.Test308_var);
            CompareActions(index, Tests.Test309_cns, Tests.Test309_var);
            CompareActions(index, Tests.Test310_cns, Tests.Test310_var);
            CompareActions(index, Tests.Test311_cns, Tests.Test311_var);
            CompareActions(index, Tests.Test312_cns, Tests.Test312_var);
            CompareActions(index, Tests.Test313_cns, Tests.Test313_var);
            CompareActions(index, Tests.Test314_cns, Tests.Test314_var);
            CompareActions(index, Tests.Test315_cns, Tests.Test315_var);
            CompareActions(index, Tests.Test316_cns, Tests.Test316_var);
            CompareActions(index, Tests.Test317_cns, Tests.Test317_var);
            CompareActions(index, Tests.Test318_cns, Tests.Test318_var);
            CompareActions(index, Tests.Test319_cns, Tests.Test319_var);
            CompareActions(index, Tests.Test320_cns, Tests.Test320_var);
            CompareActions(index, Tests.Test321_cns, Tests.Test321_var);
            CompareActions(index, Tests.Test322_cns, Tests.Test322_var);
            CompareActions(index, Tests.Test323_cns, Tests.Test323_var);
            CompareActions(index, Tests.Test324_cns, Tests.Test324_var);
            CompareActions(index, Tests.Test325_cns, Tests.Test325_var);
            CompareActions(index, Tests.Test326_cns, Tests.Test326_var);
            CompareActions(index, Tests.Test327_cns, Tests.Test327_var);
            CompareActions(index, Tests.Test328_cns, Tests.Test328_var);
            CompareActions(index, Tests.Test329_cns, Tests.Test329_var);
            CompareActions(index, Tests.Test330_cns, Tests.Test330_var);
            CompareActions(index, Tests.Test331_cns, Tests.Test331_var);
            CompareActions(index, Tests.Test332_cns, Tests.Test332_var);
            CompareActions(index, Tests.Test333_cns, Tests.Test333_var);
            CompareActions(index, Tests.Test334_cns, Tests.Test334_var);
            CompareActions(index, Tests.Test335_cns, Tests.Test335_var);
            CompareActions(index, Tests.Test336_cns, Tests.Test336_var);
            CompareActions(index, Tests.Test337_cns, Tests.Test337_var);
            CompareActions(index, Tests.Test338_cns, Tests.Test338_var);
            CompareActions(index, Tests.Test339_cns, Tests.Test339_var);
            CompareActions(index, Tests.Test340_cns, Tests.Test340_var);
            CompareActions(index, Tests.Test341_cns, Tests.Test341_var);
            CompareActions(index, Tests.Test342_cns, Tests.Test342_var);
            CompareActions(index, Tests.Test343_cns, Tests.Test343_var);
            CompareActions(index, Tests.Test344_cns, Tests.Test344_var);
            CompareActions(index, Tests.Test345_cns, Tests.Test345_var);
            CompareActions(index, Tests.Test346_cns, Tests.Test346_var);
            CompareActions(index, Tests.Test347_cns, Tests.Test347_var);
            CompareActions(index, Tests.Test348_cns, Tests.Test348_var);
            CompareActions(index, Tests.Test349_cns, Tests.Test349_var);
            CompareActions(index, Tests.Test350_cns, Tests.Test350_var);
            CompareActions(index, Tests.Test351_cns, Tests.Test351_var);
            CompareActions(index, Tests.Test352_cns, Tests.Test352_var);
            CompareActions(index, Tests.Test353_cns, Tests.Test353_var);
            CompareActions(index, Tests.Test354_cns, Tests.Test354_var);
            CompareActions(index, Tests.Test355_cns, Tests.Test355_var);
            CompareActions(index, Tests.Test356_cns, Tests.Test356_var);
            CompareActions(index, Tests.Test357_cns, Tests.Test357_var);
            CompareActions(index, Tests.Test358_cns, Tests.Test358_var);
            CompareActions(index, Tests.Test359_cns, Tests.Test359_var);
            CompareActions(index, Tests.Test360_cns, Tests.Test360_var);
            CompareActions(index, Tests.Test361_cns, Tests.Test361_var);
            CompareActions(index, Tests.Test362_cns, Tests.Test362_var);
            CompareActions(index, Tests.Test363_cns, Tests.Test363_var);
            CompareActions(index, Tests.Test364_cns, Tests.Test364_var);
            CompareActions(index, Tests.Test365_cns, Tests.Test365_var);
            CompareActions(index, Tests.Test366_cns, Tests.Test366_var);
            CompareActions(index, Tests.Test367_cns, Tests.Test367_var);
            CompareActions(index, Tests.Test368_cns, Tests.Test368_var);
            CompareActions(index, Tests.Test369_cns, Tests.Test369_var);
            CompareActions(index, Tests.Test370_cns, Tests.Test370_var);
            CompareActions(index, Tests.Test371_cns, Tests.Test371_var);
            CompareActions(index, Tests.Test372_cns, Tests.Test372_var);
            CompareActions(index, Tests.Test373_cns, Tests.Test373_var);
            CompareActions(index, Tests.Test374_cns, Tests.Test374_var);
            CompareActions(index, Tests.Test375_cns, Tests.Test375_var);
            CompareActions(index, Tests.Test376_cns, Tests.Test376_var);
            CompareActions(index, Tests.Test377_cns, Tests.Test377_var);
            CompareActions(index, Tests.Test378_cns, Tests.Test378_var);
            CompareActions(index, Tests.Test379_cns, Tests.Test379_var);
            CompareActions(index, Tests.Test380_cns, Tests.Test380_var);
            CompareActions(index, Tests.Test381_cns, Tests.Test381_var);
            CompareActions(index, Tests.Test382_cns, Tests.Test382_var);
            CompareActions(index, Tests.Test383_cns, Tests.Test383_var);
            CompareActions(index, Tests.Test384_cns, Tests.Test384_var);
            CompareActions(index, Tests.Test385_cns, Tests.Test385_var);
            CompareActions(index, Tests.Test386_cns, Tests.Test386_var);
            CompareActions(index, Tests.Test387_cns, Tests.Test387_var);
            CompareActions(index, Tests.Test388_cns, Tests.Test388_var);
            CompareActions(index, Tests.Test389_cns, Tests.Test389_var);
            CompareActions(index, Tests.Test390_cns, Tests.Test390_var);
            CompareActions(index, Tests.Test391_cns, Tests.Test391_var);
            CompareActions(index, Tests.Test392_cns, Tests.Test392_var);
            CompareActions(index, Tests.Test393_cns, Tests.Test393_var);
            CompareActions(index, Tests.Test394_cns, Tests.Test394_var);
            CompareActions(index, Tests.Test395_cns, Tests.Test395_var);
            CompareActions(index, Tests.Test396_cns, Tests.Test396_var);
            CompareActions(index, Tests.Test397_cns, Tests.Test397_var);
            CompareActions(index, Tests.Test398_cns, Tests.Test398_var);
            CompareActions(index, Tests.Test399_cns, Tests.Test399_var);
            CompareActions(index, Tests.Test400_cns, Tests.Test400_var);
            CompareActions(index, Tests.Test401_cns, Tests.Test401_var);
            CompareActions(index, Tests.Test402_cns, Tests.Test402_var);
            CompareActions(index, Tests.Test403_cns, Tests.Test403_var);
            CompareActions(index, Tests.Test404_cns, Tests.Test404_var);
            CompareActions(index, Tests.Test405_cns, Tests.Test405_var);
            CompareActions(index, Tests.Test406_cns, Tests.Test406_var);
            CompareActions(index, Tests.Test407_cns, Tests.Test407_var);
            CompareActions(index, Tests.Test408_cns, Tests.Test408_var);
            CompareActions(index, Tests.Test409_cns, Tests.Test409_var);
            CompareActions(index, Tests.Test410_cns, Tests.Test410_var);
            CompareActions(index, Tests.Test411_cns, Tests.Test411_var);
            CompareActions(index, Tests.Test412_cns, Tests.Test412_var);
            CompareActions(index, Tests.Test413_cns, Tests.Test413_var);
            CompareActions(index, Tests.Test414_cns, Tests.Test414_var);
            CompareActions(index, Tests.Test415_cns, Tests.Test415_var);
            CompareActions(index, Tests.Test416_cns, Tests.Test416_var);
            CompareActions(index, Tests.Test417_cns, Tests.Test417_var);
            CompareActions(index, Tests.Test418_cns, Tests.Test418_var);
            CompareActions(index, Tests.Test419_cns, Tests.Test419_var);
            CompareActions(index, Tests.Test420_cns, Tests.Test420_var);
            CompareActions(index, Tests.Test421_cns, Tests.Test421_var);
            CompareActions(index, Tests.Test422_cns, Tests.Test422_var);
            CompareActions(index, Tests.Test423_cns, Tests.Test423_var);
            CompareActions(index, Tests.Test424_cns, Tests.Test424_var);
            CompareActions(index, Tests.Test425_cns, Tests.Test425_var);
            CompareActions(index, Tests.Test426_cns, Tests.Test426_var);
            CompareActions(index, Tests.Test427_cns, Tests.Test427_var);
            CompareActions(index, Tests.Test428_cns, Tests.Test428_var);
            CompareActions(index, Tests.Test429_cns, Tests.Test429_var);
            CompareActions(index, Tests.Test430_cns, Tests.Test430_var);
            CompareActions(index, Tests.Test431_cns, Tests.Test431_var);
            CompareActions(index, Tests.Test432_cns, Tests.Test432_var);
            CompareActions(index, Tests.Test433_cns, Tests.Test433_var);
        }

        return returnCode;
    }

    private static void CompareActions(int index, Func<int, byte> action1, Func<int, byte> action2)
    {
        if (RunTest(() => action1(index)) !=
            RunTest(() => action2(index)))
        {
            returnCode--;
        }
    }

    private static void CompareActions(int index, Func<uint, byte> action1, Func<uint, byte> action2)
    {
        if (RunTest(() => action1((uint)index)) !=
            RunTest(() => action2((uint)index)))
        {
            returnCode--;
        }
    }

    private static (byte, Type) RunTest(Func<byte> action)
    {
        try
        {
            return (action(), null);
        }
        catch (TargetInvocationException exc)
        {
            return (0, exc.InnerException.GetType());
        }
        catch (Exception exc)
        {
            return (0, exc.GetType());
        }
    }
}

public static class Tests
{
    private static ReadOnlySpan<byte> readOnlySpan => new byte[] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };

    [MethodImpl(MethodImplOptions.AggressiveInlining)]
    private static T Cns<T>(T t) => t; // don't want Roslyn to optimize constants (e.g. "i >> 33" -> "i >> 1")

    [MethodImpl(MethodImplOptions.NoInlining)]
    private static T Var<T>(T t) => t;

    public static byte Test000_cns(int index)  => readOnlySpan[index & Cns(-2147483648)];
    public static byte Test000_var(int index)  => readOnlySpan[index & Var(-2147483648)];
    public static byte Test001_cns(int index)  => readOnlySpan[index & Cns(-2147483647)];
    public static byte Test001_var(int index)  => readOnlySpan[index & Var(-2147483647)];
    public static byte Test002_cns(int index)  => readOnlySpan[index & Cns(-11)];
    public static byte Test002_var(int index)  => readOnlySpan[index & Var(-11)];
    public static byte Test003_cns(int index)  => readOnlySpan[index & Cns(-10)];
    public static byte Test003_var(int index)  => readOnlySpan[index & Var(-10)];
    public static byte Test004_cns(int index)  => readOnlySpan[index & Cns(-9)];
    public static byte Test004_var(int index)  => readOnlySpan[index & Var(-9)];
    public static byte Test005_cns(int index)  => readOnlySpan[index & Cns(-1)];
    public static byte Test005_var(int index)  => readOnlySpan[index & Var(-1)];
    public static byte Test006_cns(int index)  => readOnlySpan[index & Cns(0)];
    public static byte Test006_var(int index)  => readOnlySpan[index & Var(0)];
    public static byte Test007_cns(int index)  => readOnlySpan[index & Cns(1)];
    public static byte Test007_var(int index)  => readOnlySpan[index & Var(1)];
    public static byte Test008_cns(int index)  => readOnlySpan[index & Cns(2)];
    public static byte Test008_var(int index)  => readOnlySpan[index & Var(2)];
    public static byte Test009_cns(int index)  => readOnlySpan[index & Cns(9)];
    public static byte Test009_var(int index)  => readOnlySpan[index & Var(9)];
    public static byte Test010_cns(int index)  => readOnlySpan[index & Cns(10)];
    public static byte Test010_var(int index)  => readOnlySpan[index & Var(10)];
    public static byte Test011_cns(int index)  => readOnlySpan[index & Cns(11)];
    public static byte Test011_var(int index)  => readOnlySpan[index & Var(11)];
    public static byte Test012_cns(int index)  => readOnlySpan[index & Cns(2147483646)];
    public static byte Test012_var(int index)  => readOnlySpan[index & Var(2147483646)];
    public static byte Test013_cns(int index)  => readOnlySpan[index & Cns(2147483647)];
    public static byte Test013_var(int index)  => readOnlySpan[index & Var(2147483647)];
    public static byte Test014_cns(int index)  => readOnlySpan[index % Cns(-2147483648)];
    public static byte Test014_var(int index)  => readOnlySpan[index % Var(-2147483648)];
    public static byte Test015_cns(int index)  => readOnlySpan[index % Cns(-2147483647)];
    public static byte Test015_var(int index)  => readOnlySpan[index % Var(-2147483647)];
    public static byte Test016_cns(int index)  => readOnlySpan[index % Cns(-11)];
    public static byte Test016_var(int index)  => readOnlySpan[index % Var(-11)];
    public static byte Test017_cns(int index)  => readOnlySpan[index % Cns(-10)];
    public static byte Test017_var(int index)  => readOnlySpan[index % Var(-10)];
    public static byte Test018_cns(int index)  => readOnlySpan[index % Cns(-9)];
    public static byte Test018_var(int index)  => readOnlySpan[index % Var(-9)];
    public static byte Test019_cns(int index)  => readOnlySpan[index % Cns(-1)];
    public static byte Test019_var(int index)  => readOnlySpan[index % Var(-1)];
    public static byte Test020_cns(int index)  => readOnlySpan[index % Cns(0)];
    public static byte Test020_var(int index)  => readOnlySpan[index % Var(0)];
    public static byte Test021_cns(int index)  => readOnlySpan[index % Cns(1)];
    public static byte Test021_var(int index)  => readOnlySpan[index % Var(1)];
    public static byte Test022_cns(int index)  => readOnlySpan[index % Cns(2)];
    public static byte Test022_var(int index)  => readOnlySpan[index % Var(2)];
    public static byte Test023_cns(int index)  => readOnlySpan[index % Cns(9)];
    public static byte Test023_var(int index)  => readOnlySpan[index % Var(9)];
    public static byte Test024_cns(int index)  => readOnlySpan[index % Cns(10)];
    public static byte Test024_var(int index)  => readOnlySpan[index % Var(10)];
    public static byte Test025_cns(int index)  => readOnlySpan[index % Cns(11)];
    public static byte Test025_var(int index)  => readOnlySpan[index % Var(11)];
    public static byte Test026_cns(int index)  => readOnlySpan[index % Cns(2147483646)];
    public static byte Test026_var(int index)  => readOnlySpan[index % Var(2147483646)];
    public static byte Test027_cns(int index)  => readOnlySpan[index % Cns(2147483647)];
    public static byte Test027_var(int index)  => readOnlySpan[index % Var(2147483647)];
    public static byte Test028_cns(uint index) => readOnlySpan[(int)(index % Cns(-2147483648))];
    public static byte Test028_var(uint index) => readOnlySpan[(int)(index % Var(-2147483648))];
    public static byte Test029_cns(uint index) => readOnlySpan[(int)(index % Cns(-2147483647))];
    public static byte Test029_var(uint index) => readOnlySpan[(int)(index % Var(-2147483647))];
    public static byte Test030_cns(uint index) => readOnlySpan[(int)(index % Cns(-11))];
    public static byte Test030_var(uint index) => readOnlySpan[(int)(index % Var(-11))];
    public static byte Test031_cns(uint index) => readOnlySpan[(int)(index % Cns(-10))];
    public static byte Test031_var(uint index) => readOnlySpan[(int)(index % Var(-10))];
    public static byte Test032_cns(uint index) => readOnlySpan[(int)(index % Cns(-9))];
    public static byte Test032_var(uint index) => readOnlySpan[(int)(index % Var(-9))];
    public static byte Test033_cns(uint index) => readOnlySpan[(int)(index % Cns(-1))];
    public static byte Test033_var(uint index) => readOnlySpan[(int)(index % Var(-1))];
    public static byte Test034_cns(uint index) => readOnlySpan[(int)(index % Cns(0))];
    public static byte Test034_var(uint index) => readOnlySpan[(int)(index % Var(0))];
    public static byte Test035_cns(uint index) => readOnlySpan[(int)(index % Cns(1))];
    public static byte Test035_var(uint index) => readOnlySpan[(int)(index % Var(1))];
    public static byte Test036_cns(uint index) => readOnlySpan[(int)(index % Cns(2))];
    public static byte Test036_var(uint index) => readOnlySpan[(int)(index % Var(2))];
    public static byte Test037_cns(uint index) => readOnlySpan[(int)(index % Cns(9))];
    public static byte Test037_var(uint index) => readOnlySpan[(int)(index % Var(9))];
    public static byte Test038_cns(uint index) => readOnlySpan[(int)(index % Cns(10))];
    public static byte Test038_var(uint index) => readOnlySpan[(int)(index % Var(10))];
    public static byte Test039_cns(uint index) => readOnlySpan[(int)(index % Cns(11))];
    public static byte Test039_var(uint index) => readOnlySpan[(int)(index % Var(11))];
    public static byte Test040_cns(uint index) => readOnlySpan[(int)(index % Cns(2147483646))];
    public static byte Test040_var(uint index) => readOnlySpan[(int)(index % Var(2147483646))];
    public static byte Test041_cns(uint index) => readOnlySpan[(int)(index % Cns(2147483647))];
    public static byte Test041_var(uint index) => readOnlySpan[(int)(index % Var(2147483647))];
    public static byte Test042_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(-2147483648)];
    public static byte Test042_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(-2147483648)];
    public static byte Test043_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(-2147483647)];
    public static byte Test043_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(-2147483647)];
    public static byte Test044_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(-33)];
    public static byte Test044_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(-33)];
    public static byte Test045_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(-32)];
    public static byte Test045_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(-32)];
    public static byte Test046_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(-31)];
    public static byte Test046_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(-31)];
    public static byte Test047_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(-1)];
    public static byte Test047_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(-1)];
    public static byte Test048_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(0)];
    public static byte Test048_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(0)];
    public static byte Test049_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(1)];
    public static byte Test049_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(1)];
    public static byte Test050_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(2)];
    public static byte Test050_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(2)];
    public static byte Test051_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(31)];
    public static byte Test051_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(31)];
    public static byte Test052_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(32)];
    public static byte Test052_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(32)];
    public static byte Test053_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(33)];
    public static byte Test053_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(33)];
    public static byte Test054_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(2147483646)];
    public static byte Test054_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(2147483646)];
    public static byte Test055_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) >> Cns(2147483647)];
    public static byte Test055_var(int index)  => readOnlySpan[(index & Var(-2147483648)) >> Var(2147483647)];
    public static byte Test056_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(-2147483648)];
    public static byte Test056_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(-2147483648)];
    public static byte Test057_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(-2147483647)];
    public static byte Test057_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(-2147483647)];
    public static byte Test058_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(-33)];
    public static byte Test058_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(-33)];
    public static byte Test059_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(-32)];
    public static byte Test059_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(-32)];
    public static byte Test060_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(-31)];
    public static byte Test060_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(-31)];
    public static byte Test061_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(-1)];
    public static byte Test061_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(-1)];
    public static byte Test062_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(0)];
    public static byte Test062_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(0)];
    public static byte Test063_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(1)];
    public static byte Test063_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(1)];
    public static byte Test064_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(2)];
    public static byte Test064_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(2)];
    public static byte Test065_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(31)];
    public static byte Test065_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(31)];
    public static byte Test066_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(32)];
    public static byte Test066_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(32)];
    public static byte Test067_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(33)];
    public static byte Test067_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(33)];
    public static byte Test068_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(2147483646)];
    public static byte Test068_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(2147483646)];
    public static byte Test069_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) >> Cns(2147483647)];
    public static byte Test069_var(int index)  => readOnlySpan[(index & Var(-2147483647)) >> Var(2147483647)];
    public static byte Test070_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(-2147483648)];
    public static byte Test070_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(-2147483648)];
    public static byte Test071_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(-2147483647)];
    public static byte Test071_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(-2147483647)];
    public static byte Test072_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(-33)];
    public static byte Test072_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(-33)];
    public static byte Test073_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(-32)];
    public static byte Test073_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(-32)];
    public static byte Test074_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(-31)];
    public static byte Test074_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(-31)];
    public static byte Test075_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(-1)];
    public static byte Test075_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(-1)];
    public static byte Test076_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(0)];
    public static byte Test076_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(0)];
    public static byte Test077_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(1)];
    public static byte Test077_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(1)];
    public static byte Test078_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(2)];
    public static byte Test078_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(2)];
    public static byte Test079_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(31)];
    public static byte Test079_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(31)];
    public static byte Test080_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(32)];
    public static byte Test080_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(32)];
    public static byte Test081_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(33)];
    public static byte Test081_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(33)];
    public static byte Test082_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(2147483646)];
    public static byte Test082_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(2147483646)];
    public static byte Test083_cns(int index)  => readOnlySpan[(index & Cns(-11)) >> Cns(2147483647)];
    public static byte Test083_var(int index)  => readOnlySpan[(index & Var(-11)) >> Var(2147483647)];
    public static byte Test084_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(-2147483648)];
    public static byte Test084_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(-2147483648)];
    public static byte Test085_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(-2147483647)];
    public static byte Test085_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(-2147483647)];
    public static byte Test086_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(-33)];
    public static byte Test086_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(-33)];
    public static byte Test087_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(-32)];
    public static byte Test087_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(-32)];
    public static byte Test088_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(-31)];
    public static byte Test088_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(-31)];
    public static byte Test089_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(-1)];
    public static byte Test089_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(-1)];
    public static byte Test090_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(0)];
    public static byte Test090_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(0)];
    public static byte Test091_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(1)];
    public static byte Test091_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(1)];
    public static byte Test092_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(2)];
    public static byte Test092_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(2)];
    public static byte Test093_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(31)];
    public static byte Test093_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(31)];
    public static byte Test094_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(32)];
    public static byte Test094_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(32)];
    public static byte Test095_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(33)];
    public static byte Test095_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(33)];
    public static byte Test096_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(2147483646)];
    public static byte Test096_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(2147483646)];
    public static byte Test097_cns(int index)  => readOnlySpan[(index & Cns(-10)) >> Cns(2147483647)];
    public static byte Test097_var(int index)  => readOnlySpan[(index & Var(-10)) >> Var(2147483647)];
    public static byte Test098_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(-2147483648)];
    public static byte Test098_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(-2147483648)];
    public static byte Test099_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(-2147483647)];
    public static byte Test099_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(-2147483647)];
    public static byte Test100_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(-33)];
    public static byte Test100_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(-33)];
    public static byte Test101_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(-32)];
    public static byte Test101_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(-32)];
    public static byte Test102_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(-31)];
    public static byte Test102_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(-31)];
    public static byte Test103_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(-1)];
    public static byte Test103_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(-1)];
    public static byte Test104_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(0)];
    public static byte Test104_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(0)];
    public static byte Test105_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(1)];
    public static byte Test105_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(1)];
    public static byte Test106_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(2)];
    public static byte Test106_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(2)];
    public static byte Test107_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(31)];
    public static byte Test107_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(31)];
    public static byte Test108_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(32)];
    public static byte Test108_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(32)];
    public static byte Test109_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(33)];
    public static byte Test109_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(33)];
    public static byte Test110_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(2147483646)];
    public static byte Test110_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(2147483646)];
    public static byte Test111_cns(int index)  => readOnlySpan[(index & Cns(-9)) >> Cns(2147483647)];
    public static byte Test111_var(int index)  => readOnlySpan[(index & Var(-9)) >> Var(2147483647)];
    public static byte Test112_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(-2147483648)];
    public static byte Test112_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(-2147483648)];
    public static byte Test113_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(-2147483647)];
    public static byte Test113_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(-2147483647)];
    public static byte Test114_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(-33)];
    public static byte Test114_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(-33)];
    public static byte Test115_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(-32)];
    public static byte Test115_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(-32)];
    public static byte Test116_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(-31)];
    public static byte Test116_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(-31)];
    public static byte Test117_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(-1)];
    public static byte Test117_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(-1)];
    public static byte Test118_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(0)];
    public static byte Test118_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(0)];
    public static byte Test119_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(1)];
    public static byte Test119_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(1)];
    public static byte Test120_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(2)];
    public static byte Test120_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(2)];
    public static byte Test121_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(31)];
    public static byte Test121_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(31)];
    public static byte Test122_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(32)];
    public static byte Test122_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(32)];
    public static byte Test123_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(33)];
    public static byte Test123_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(33)];
    public static byte Test124_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(2147483646)];
    public static byte Test124_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(2147483646)];
    public static byte Test125_cns(int index)  => readOnlySpan[(index & Cns(-1)) >> Cns(2147483647)];
    public static byte Test125_var(int index)  => readOnlySpan[(index & Var(-1)) >> Var(2147483647)];
    public static byte Test126_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(-2147483648)];
    public static byte Test126_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(-2147483648)];
    public static byte Test127_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(-2147483647)];
    public static byte Test127_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(-2147483647)];
    public static byte Test128_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(-33)];
    public static byte Test128_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(-33)];
    public static byte Test129_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(-32)];
    public static byte Test129_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(-32)];
    public static byte Test130_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(-31)];
    public static byte Test130_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(-31)];
    public static byte Test131_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(-1)];
    public static byte Test131_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(-1)];
    public static byte Test132_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(0)];
    public static byte Test132_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(0)];
    public static byte Test133_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(1)];
    public static byte Test133_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(1)];
    public static byte Test134_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(2)];
    public static byte Test134_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(2)];
    public static byte Test135_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(31)];
    public static byte Test135_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(31)];
    public static byte Test136_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(32)];
    public static byte Test136_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(32)];
    public static byte Test137_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(33)];
    public static byte Test137_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(33)];
    public static byte Test138_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(2147483646)];
    public static byte Test138_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(2147483646)];
    public static byte Test139_cns(int index)  => readOnlySpan[(index & Cns(0)) >> Cns(2147483647)];
    public static byte Test139_var(int index)  => readOnlySpan[(index & Var(0)) >> Var(2147483647)];
    public static byte Test140_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(-2147483648)];
    public static byte Test140_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(-2147483648)];
    public static byte Test141_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(-2147483647)];
    public static byte Test141_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(-2147483647)];
    public static byte Test142_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(-33)];
    public static byte Test142_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(-33)];
    public static byte Test143_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(-32)];
    public static byte Test143_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(-32)];
    public static byte Test144_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(-31)];
    public static byte Test144_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(-31)];
    public static byte Test145_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(-1)];
    public static byte Test145_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(-1)];
    public static byte Test146_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(0)];
    public static byte Test146_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(0)];
    public static byte Test147_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(1)];
    public static byte Test147_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(1)];
    public static byte Test148_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(2)];
    public static byte Test148_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(2)];
    public static byte Test149_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(31)];
    public static byte Test149_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(31)];
    public static byte Test150_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(32)];
    public static byte Test150_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(32)];
    public static byte Test151_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(33)];
    public static byte Test151_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(33)];
    public static byte Test152_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(2147483646)];
    public static byte Test152_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(2147483646)];
    public static byte Test153_cns(int index)  => readOnlySpan[(index & Cns(1)) >> Cns(2147483647)];
    public static byte Test153_var(int index)  => readOnlySpan[(index & Var(1)) >> Var(2147483647)];
    public static byte Test154_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(-2147483648)];
    public static byte Test154_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(-2147483648)];
    public static byte Test155_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(-2147483647)];
    public static byte Test155_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(-2147483647)];
    public static byte Test156_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(-33)];
    public static byte Test156_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(-33)];
    public static byte Test157_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(-32)];
    public static byte Test157_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(-32)];
    public static byte Test158_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(-31)];
    public static byte Test158_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(-31)];
    public static byte Test159_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(-1)];
    public static byte Test159_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(-1)];
    public static byte Test160_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(0)];
    public static byte Test160_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(0)];
    public static byte Test161_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(1)];
    public static byte Test161_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(1)];
    public static byte Test162_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(2)];
    public static byte Test162_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(2)];
    public static byte Test163_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(31)];
    public static byte Test163_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(31)];
    public static byte Test164_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(32)];
    public static byte Test164_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(32)];
    public static byte Test165_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(33)];
    public static byte Test165_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(33)];
    public static byte Test166_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(2147483646)];
    public static byte Test166_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(2147483646)];
    public static byte Test167_cns(int index)  => readOnlySpan[(index & Cns(2)) >> Cns(2147483647)];
    public static byte Test167_var(int index)  => readOnlySpan[(index & Var(2)) >> Var(2147483647)];
    public static byte Test168_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(-2147483648)];
    public static byte Test168_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(-2147483648)];
    public static byte Test169_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(-2147483647)];
    public static byte Test169_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(-2147483647)];
    public static byte Test170_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(-33)];
    public static byte Test170_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(-33)];
    public static byte Test171_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(-32)];
    public static byte Test171_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(-32)];
    public static byte Test172_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(-31)];
    public static byte Test172_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(-31)];
    public static byte Test173_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(-1)];
    public static byte Test173_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(-1)];
    public static byte Test174_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(0)];
    public static byte Test174_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(0)];
    public static byte Test175_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(1)];
    public static byte Test175_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(1)];
    public static byte Test176_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(2)];
    public static byte Test176_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(2)];
    public static byte Test177_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(31)];
    public static byte Test177_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(31)];
    public static byte Test178_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(32)];
    public static byte Test178_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(32)];
    public static byte Test179_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(33)];
    public static byte Test179_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(33)];
    public static byte Test180_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(2147483646)];
    public static byte Test180_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(2147483646)];
    public static byte Test181_cns(int index)  => readOnlySpan[(index & Cns(9)) >> Cns(2147483647)];
    public static byte Test181_var(int index)  => readOnlySpan[(index & Var(9)) >> Var(2147483647)];
    public static byte Test182_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(-2147483648)];
    public static byte Test182_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(-2147483648)];
    public static byte Test183_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(-2147483647)];
    public static byte Test183_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(-2147483647)];
    public static byte Test184_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(-33)];
    public static byte Test184_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(-33)];
    public static byte Test185_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(-32)];
    public static byte Test185_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(-32)];
    public static byte Test186_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(-31)];
    public static byte Test186_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(-31)];
    public static byte Test187_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(-1)];
    public static byte Test187_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(-1)];
    public static byte Test188_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(0)];
    public static byte Test188_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(0)];
    public static byte Test189_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(1)];
    public static byte Test189_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(1)];
    public static byte Test190_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(2)];
    public static byte Test190_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(2)];
    public static byte Test191_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(31)];
    public static byte Test191_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(31)];
    public static byte Test192_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(32)];
    public static byte Test192_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(32)];
    public static byte Test193_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(33)];
    public static byte Test193_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(33)];
    public static byte Test194_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(2147483646)];
    public static byte Test194_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(2147483646)];
    public static byte Test195_cns(int index)  => readOnlySpan[(index & Cns(10)) >> Cns(2147483647)];
    public static byte Test195_var(int index)  => readOnlySpan[(index & Var(10)) >> Var(2147483647)];
    public static byte Test196_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(-2147483648)];
    public static byte Test196_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(-2147483648)];
    public static byte Test197_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(-2147483647)];
    public static byte Test197_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(-2147483647)];
    public static byte Test198_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(-33)];
    public static byte Test198_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(-33)];
    public static byte Test199_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(-32)];
    public static byte Test199_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(-32)];
    public static byte Test200_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(-31)];
    public static byte Test200_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(-31)];
    public static byte Test201_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(-1)];
    public static byte Test201_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(-1)];
    public static byte Test202_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(0)];
    public static byte Test202_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(0)];
    public static byte Test203_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(1)];
    public static byte Test203_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(1)];
    public static byte Test204_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(2)];
    public static byte Test204_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(2)];
    public static byte Test205_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(31)];
    public static byte Test205_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(31)];
    public static byte Test206_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(32)];
    public static byte Test206_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(32)];
    public static byte Test207_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(33)];
    public static byte Test207_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(33)];
    public static byte Test208_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(2147483646)];
    public static byte Test208_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(2147483646)];
    public static byte Test209_cns(int index)  => readOnlySpan[(index & Cns(11)) >> Cns(2147483647)];
    public static byte Test209_var(int index)  => readOnlySpan[(index & Var(11)) >> Var(2147483647)];
    public static byte Test210_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(-2147483648)];
    public static byte Test210_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(-2147483648)];
    public static byte Test211_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(-2147483647)];
    public static byte Test211_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(-2147483647)];
    public static byte Test212_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(-33)];
    public static byte Test212_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(-33)];
    public static byte Test213_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(-32)];
    public static byte Test213_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(-32)];
    public static byte Test214_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(-31)];
    public static byte Test214_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(-31)];
    public static byte Test215_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(-1)];
    public static byte Test215_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(-1)];
    public static byte Test216_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(0)];
    public static byte Test216_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(0)];
    public static byte Test217_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(1)];
    public static byte Test217_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(1)];
    public static byte Test218_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(2)];
    public static byte Test218_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(2)];
    public static byte Test219_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(31)];
    public static byte Test219_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(31)];
    public static byte Test220_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(32)];
    public static byte Test220_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(32)];
    public static byte Test221_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(33)];
    public static byte Test221_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(33)];
    public static byte Test222_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(2147483646)];
    public static byte Test222_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(2147483646)];
    public static byte Test223_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) >> Cns(2147483647)];
    public static byte Test223_var(int index)  => readOnlySpan[(index & Var(2147483646)) >> Var(2147483647)];
    public static byte Test224_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(-2147483648)];
    public static byte Test224_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(-2147483648)];
    public static byte Test225_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(-2147483647)];
    public static byte Test225_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(-2147483647)];
    public static byte Test226_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(-33)];
    public static byte Test226_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(-33)];
    public static byte Test227_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(-32)];
    public static byte Test227_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(-32)];
    public static byte Test228_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(-31)];
    public static byte Test228_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(-31)];
    public static byte Test229_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(-1)];
    public static byte Test229_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(-1)];
    public static byte Test230_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(0)];
    public static byte Test230_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(0)];
    public static byte Test231_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(1)];
    public static byte Test231_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(1)];
    public static byte Test232_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(2)];
    public static byte Test232_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(2)];
    public static byte Test233_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(31)];
    public static byte Test233_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(31)];
    public static byte Test234_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(32)];
    public static byte Test234_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(32)];
    public static byte Test235_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(33)];
    public static byte Test235_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(33)];
    public static byte Test236_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(2147483646)];
    public static byte Test236_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(2147483646)];
    public static byte Test237_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) >> Cns(2147483647)];
    public static byte Test237_var(int index)  => readOnlySpan[(index & Var(2147483647)) >> Var(2147483647)];
    public static byte Test238_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(-2147483648)];
    public static byte Test238_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(-2147483648)];
    public static byte Test239_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(-2147483647)];
    public static byte Test239_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(-2147483647)];
    public static byte Test240_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(-33)];
    public static byte Test240_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(-33)];
    public static byte Test241_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(-32)];
    public static byte Test241_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(-32)];
    public static byte Test242_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(-31)];
    public static byte Test242_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(-31)];
    public static byte Test243_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(-1)];
    public static byte Test243_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(-1)];
    public static byte Test244_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(0)];
    public static byte Test244_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(0)];
    public static byte Test245_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(1)];
    public static byte Test245_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(1)];
    public static byte Test246_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(2)];
    public static byte Test246_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(2)];
    public static byte Test247_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(31)];
    public static byte Test247_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(31)];
    public static byte Test248_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(32)];
    public static byte Test248_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(32)];
    public static byte Test249_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(33)];
    public static byte Test249_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(33)];
    public static byte Test250_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(2147483646)];
    public static byte Test250_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(2147483646)];
    public static byte Test251_cns(int index)  => readOnlySpan[(index & Cns(-2147483648)) << Cns(2147483647)];
    public static byte Test251_var(int index)  => readOnlySpan[(index & Var(-2147483648)) << Var(2147483647)];
    public static byte Test252_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(-2147483648)];
    public static byte Test252_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(-2147483648)];
    public static byte Test253_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(-2147483647)];
    public static byte Test253_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(-2147483647)];
    public static byte Test254_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(-33)];
    public static byte Test254_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(-33)];
    public static byte Test255_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(-32)];
    public static byte Test255_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(-32)];
    public static byte Test256_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(-31)];
    public static byte Test256_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(-31)];
    public static byte Test257_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(-1)];
    public static byte Test257_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(-1)];
    public static byte Test258_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(0)];
    public static byte Test258_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(0)];
    public static byte Test259_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(1)];
    public static byte Test259_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(1)];
    public static byte Test260_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(2)];
    public static byte Test260_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(2)];
    public static byte Test261_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(31)];
    public static byte Test261_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(31)];
    public static byte Test262_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(32)];
    public static byte Test262_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(32)];
    public static byte Test263_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(33)];
    public static byte Test263_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(33)];
    public static byte Test264_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(2147483646)];
    public static byte Test264_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(2147483646)];
    public static byte Test265_cns(int index)  => readOnlySpan[(index & Cns(-2147483647)) << Cns(2147483647)];
    public static byte Test265_var(int index)  => readOnlySpan[(index & Var(-2147483647)) << Var(2147483647)];
    public static byte Test266_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(-2147483648)];
    public static byte Test266_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(-2147483648)];
    public static byte Test267_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(-2147483647)];
    public static byte Test267_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(-2147483647)];
    public static byte Test268_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(-33)];
    public static byte Test268_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(-33)];
    public static byte Test269_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(-32)];
    public static byte Test269_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(-32)];
    public static byte Test270_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(-31)];
    public static byte Test270_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(-31)];
    public static byte Test271_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(-1)];
    public static byte Test271_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(-1)];
    public static byte Test272_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(0)];
    public static byte Test272_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(0)];
    public static byte Test273_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(1)];
    public static byte Test273_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(1)];
    public static byte Test274_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(2)];
    public static byte Test274_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(2)];
    public static byte Test275_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(31)];
    public static byte Test275_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(31)];
    public static byte Test276_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(32)];
    public static byte Test276_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(32)];
    public static byte Test277_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(33)];
    public static byte Test277_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(33)];
    public static byte Test278_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(2147483646)];
    public static byte Test278_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(2147483646)];
    public static byte Test279_cns(int index)  => readOnlySpan[(index & Cns(-11)) << Cns(2147483647)];
    public static byte Test279_var(int index)  => readOnlySpan[(index & Var(-11)) << Var(2147483647)];
    public static byte Test280_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(-2147483648)];
    public static byte Test280_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(-2147483648)];
    public static byte Test281_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(-2147483647)];
    public static byte Test281_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(-2147483647)];
    public static byte Test282_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(-33)];
    public static byte Test282_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(-33)];
    public static byte Test283_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(-32)];
    public static byte Test283_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(-32)];
    public static byte Test284_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(-31)];
    public static byte Test284_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(-31)];
    public static byte Test285_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(-1)];
    public static byte Test285_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(-1)];
    public static byte Test286_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(0)];
    public static byte Test286_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(0)];
    public static byte Test287_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(1)];
    public static byte Test287_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(1)];
    public static byte Test288_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(2)];
    public static byte Test288_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(2)];
    public static byte Test289_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(31)];
    public static byte Test289_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(31)];
    public static byte Test290_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(32)];
    public static byte Test290_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(32)];
    public static byte Test291_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(33)];
    public static byte Test291_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(33)];
    public static byte Test292_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(2147483646)];
    public static byte Test292_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(2147483646)];
    public static byte Test293_cns(int index)  => readOnlySpan[(index & Cns(-10)) << Cns(2147483647)];
    public static byte Test293_var(int index)  => readOnlySpan[(index & Var(-10)) << Var(2147483647)];
    public static byte Test294_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(-2147483648)];
    public static byte Test294_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(-2147483648)];
    public static byte Test295_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(-2147483647)];
    public static byte Test295_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(-2147483647)];
    public static byte Test296_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(-33)];
    public static byte Test296_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(-33)];
    public static byte Test297_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(-32)];
    public static byte Test297_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(-32)];
    public static byte Test298_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(-31)];
    public static byte Test298_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(-31)];
    public static byte Test299_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(-1)];
    public static byte Test299_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(-1)];
    public static byte Test300_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(0)];
    public static byte Test300_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(0)];
    public static byte Test301_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(1)];
    public static byte Test301_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(1)];
    public static byte Test302_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(2)];
    public static byte Test302_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(2)];
    public static byte Test303_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(31)];
    public static byte Test303_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(31)];
    public static byte Test304_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(32)];
    public static byte Test304_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(32)];
    public static byte Test305_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(33)];
    public static byte Test305_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(33)];
    public static byte Test306_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(2147483646)];
    public static byte Test306_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(2147483646)];
    public static byte Test307_cns(int index)  => readOnlySpan[(index & Cns(-9)) << Cns(2147483647)];
    public static byte Test307_var(int index)  => readOnlySpan[(index & Var(-9)) << Var(2147483647)];
    public static byte Test308_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(-2147483648)];
    public static byte Test308_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(-2147483648)];
    public static byte Test309_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(-2147483647)];
    public static byte Test309_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(-2147483647)];
    public static byte Test310_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(-33)];
    public static byte Test310_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(-33)];
    public static byte Test311_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(-32)];
    public static byte Test311_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(-32)];
    public static byte Test312_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(-31)];
    public static byte Test312_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(-31)];
    public static byte Test313_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(-1)];
    public static byte Test313_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(-1)];
    public static byte Test314_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(0)];
    public static byte Test314_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(0)];
    public static byte Test315_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(1)];
    public static byte Test315_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(1)];
    public static byte Test316_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(2)];
    public static byte Test316_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(2)];
    public static byte Test317_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(31)];
    public static byte Test317_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(31)];
    public static byte Test318_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(32)];
    public static byte Test318_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(32)];
    public static byte Test319_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(33)];
    public static byte Test319_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(33)];
    public static byte Test320_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(2147483646)];
    public static byte Test320_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(2147483646)];
    public static byte Test321_cns(int index)  => readOnlySpan[(index & Cns(-1)) << Cns(2147483647)];
    public static byte Test321_var(int index)  => readOnlySpan[(index & Var(-1)) << Var(2147483647)];
    public static byte Test322_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(-2147483648)];
    public static byte Test322_var(int index)  => readOnlySpan[(index & Var(0)) << Var(-2147483648)];
    public static byte Test323_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(-2147483647)];
    public static byte Test323_var(int index)  => readOnlySpan[(index & Var(0)) << Var(-2147483647)];
    public static byte Test324_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(-33)];
    public static byte Test324_var(int index)  => readOnlySpan[(index & Var(0)) << Var(-33)];
    public static byte Test325_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(-32)];
    public static byte Test325_var(int index)  => readOnlySpan[(index & Var(0)) << Var(-32)];
    public static byte Test326_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(-31)];
    public static byte Test326_var(int index)  => readOnlySpan[(index & Var(0)) << Var(-31)];
    public static byte Test327_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(-1)];
    public static byte Test327_var(int index)  => readOnlySpan[(index & Var(0)) << Var(-1)];
    public static byte Test328_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(0)];
    public static byte Test328_var(int index)  => readOnlySpan[(index & Var(0)) << Var(0)];
    public static byte Test329_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(1)];
    public static byte Test329_var(int index)  => readOnlySpan[(index & Var(0)) << Var(1)];
    public static byte Test330_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(2)];
    public static byte Test330_var(int index)  => readOnlySpan[(index & Var(0)) << Var(2)];
    public static byte Test331_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(31)];
    public static byte Test331_var(int index)  => readOnlySpan[(index & Var(0)) << Var(31)];
    public static byte Test332_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(32)];
    public static byte Test332_var(int index)  => readOnlySpan[(index & Var(0)) << Var(32)];
    public static byte Test333_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(33)];
    public static byte Test333_var(int index)  => readOnlySpan[(index & Var(0)) << Var(33)];
    public static byte Test334_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(2147483646)];
    public static byte Test334_var(int index)  => readOnlySpan[(index & Var(0)) << Var(2147483646)];
    public static byte Test335_cns(int index)  => readOnlySpan[(index & Cns(0)) << Cns(2147483647)];
    public static byte Test335_var(int index)  => readOnlySpan[(index & Var(0)) << Var(2147483647)];
    public static byte Test336_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(-2147483648)];
    public static byte Test336_var(int index)  => readOnlySpan[(index & Var(1)) << Var(-2147483648)];
    public static byte Test337_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(-2147483647)];
    public static byte Test337_var(int index)  => readOnlySpan[(index & Var(1)) << Var(-2147483647)];
    public static byte Test338_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(-33)];
    public static byte Test338_var(int index)  => readOnlySpan[(index & Var(1)) << Var(-33)];
    public static byte Test339_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(-32)];
    public static byte Test339_var(int index)  => readOnlySpan[(index & Var(1)) << Var(-32)];
    public static byte Test340_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(-31)];
    public static byte Test340_var(int index)  => readOnlySpan[(index & Var(1)) << Var(-31)];
    public static byte Test341_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(-1)];
    public static byte Test341_var(int index)  => readOnlySpan[(index & Var(1)) << Var(-1)];
    public static byte Test342_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(0)];
    public static byte Test342_var(int index)  => readOnlySpan[(index & Var(1)) << Var(0)];
    public static byte Test343_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(1)];
    public static byte Test343_var(int index)  => readOnlySpan[(index & Var(1)) << Var(1)];
    public static byte Test344_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(2)];
    public static byte Test344_var(int index)  => readOnlySpan[(index & Var(1)) << Var(2)];
    public static byte Test345_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(31)];
    public static byte Test345_var(int index)  => readOnlySpan[(index & Var(1)) << Var(31)];
    public static byte Test346_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(32)];
    public static byte Test346_var(int index)  => readOnlySpan[(index & Var(1)) << Var(32)];
    public static byte Test347_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(33)];
    public static byte Test347_var(int index)  => readOnlySpan[(index & Var(1)) << Var(33)];
    public static byte Test348_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(2147483646)];
    public static byte Test348_var(int index)  => readOnlySpan[(index & Var(1)) << Var(2147483646)];
    public static byte Test349_cns(int index)  => readOnlySpan[(index & Cns(1)) << Cns(2147483647)];
    public static byte Test349_var(int index)  => readOnlySpan[(index & Var(1)) << Var(2147483647)];
    public static byte Test350_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(-2147483648)];
    public static byte Test350_var(int index)  => readOnlySpan[(index & Var(2)) << Var(-2147483648)];
    public static byte Test351_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(-2147483647)];
    public static byte Test351_var(int index)  => readOnlySpan[(index & Var(2)) << Var(-2147483647)];
    public static byte Test352_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(-33)];
    public static byte Test352_var(int index)  => readOnlySpan[(index & Var(2)) << Var(-33)];
    public static byte Test353_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(-32)];
    public static byte Test353_var(int index)  => readOnlySpan[(index & Var(2)) << Var(-32)];
    public static byte Test354_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(-31)];
    public static byte Test354_var(int index)  => readOnlySpan[(index & Var(2)) << Var(-31)];
    public static byte Test355_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(-1)];
    public static byte Test355_var(int index)  => readOnlySpan[(index & Var(2)) << Var(-1)];
    public static byte Test356_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(0)];
    public static byte Test356_var(int index)  => readOnlySpan[(index & Var(2)) << Var(0)];
    public static byte Test357_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(1)];
    public static byte Test357_var(int index)  => readOnlySpan[(index & Var(2)) << Var(1)];
    public static byte Test358_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(2)];
    public static byte Test358_var(int index)  => readOnlySpan[(index & Var(2)) << Var(2)];
    public static byte Test359_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(31)];
    public static byte Test359_var(int index)  => readOnlySpan[(index & Var(2)) << Var(31)];
    public static byte Test360_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(32)];
    public static byte Test360_var(int index)  => readOnlySpan[(index & Var(2)) << Var(32)];
    public static byte Test361_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(33)];
    public static byte Test361_var(int index)  => readOnlySpan[(index & Var(2)) << Var(33)];
    public static byte Test362_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(2147483646)];
    public static byte Test362_var(int index)  => readOnlySpan[(index & Var(2)) << Var(2147483646)];
    public static byte Test363_cns(int index)  => readOnlySpan[(index & Cns(2)) << Cns(2147483647)];
    public static byte Test363_var(int index)  => readOnlySpan[(index & Var(2)) << Var(2147483647)];
    public static byte Test364_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(-2147483648)];
    public static byte Test364_var(int index)  => readOnlySpan[(index & Var(9)) << Var(-2147483648)];
    public static byte Test365_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(-2147483647)];
    public static byte Test365_var(int index)  => readOnlySpan[(index & Var(9)) << Var(-2147483647)];
    public static byte Test366_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(-33)];
    public static byte Test366_var(int index)  => readOnlySpan[(index & Var(9)) << Var(-33)];
    public static byte Test367_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(-32)];
    public static byte Test367_var(int index)  => readOnlySpan[(index & Var(9)) << Var(-32)];
    public static byte Test368_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(-31)];
    public static byte Test368_var(int index)  => readOnlySpan[(index & Var(9)) << Var(-31)];
    public static byte Test369_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(-1)];
    public static byte Test369_var(int index)  => readOnlySpan[(index & Var(9)) << Var(-1)];
    public static byte Test370_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(0)];
    public static byte Test370_var(int index)  => readOnlySpan[(index & Var(9)) << Var(0)];
    public static byte Test371_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(1)];
    public static byte Test371_var(int index)  => readOnlySpan[(index & Var(9)) << Var(1)];
    public static byte Test372_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(2)];
    public static byte Test372_var(int index)  => readOnlySpan[(index & Var(9)) << Var(2)];
    public static byte Test373_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(31)];
    public static byte Test373_var(int index)  => readOnlySpan[(index & Var(9)) << Var(31)];
    public static byte Test374_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(32)];
    public static byte Test374_var(int index)  => readOnlySpan[(index & Var(9)) << Var(32)];
    public static byte Test375_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(33)];
    public static byte Test375_var(int index)  => readOnlySpan[(index & Var(9)) << Var(33)];
    public static byte Test376_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(2147483646)];
    public static byte Test376_var(int index)  => readOnlySpan[(index & Var(9)) << Var(2147483646)];
    public static byte Test377_cns(int index)  => readOnlySpan[(index & Cns(9)) << Cns(2147483647)];
    public static byte Test377_var(int index)  => readOnlySpan[(index & Var(9)) << Var(2147483647)];
    public static byte Test378_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(-2147483648)];
    public static byte Test378_var(int index)  => readOnlySpan[(index & Var(10)) << Var(-2147483648)];
    public static byte Test379_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(-2147483647)];
    public static byte Test379_var(int index)  => readOnlySpan[(index & Var(10)) << Var(-2147483647)];
    public static byte Test380_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(-33)];
    public static byte Test380_var(int index)  => readOnlySpan[(index & Var(10)) << Var(-33)];
    public static byte Test381_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(-32)];
    public static byte Test381_var(int index)  => readOnlySpan[(index & Var(10)) << Var(-32)];
    public static byte Test382_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(-31)];
    public static byte Test382_var(int index)  => readOnlySpan[(index & Var(10)) << Var(-31)];
    public static byte Test383_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(-1)];
    public static byte Test383_var(int index)  => readOnlySpan[(index & Var(10)) << Var(-1)];
    public static byte Test384_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(0)];
    public static byte Test384_var(int index)  => readOnlySpan[(index & Var(10)) << Var(0)];
    public static byte Test385_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(1)];
    public static byte Test385_var(int index)  => readOnlySpan[(index & Var(10)) << Var(1)];
    public static byte Test386_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(2)];
    public static byte Test386_var(int index)  => readOnlySpan[(index & Var(10)) << Var(2)];
    public static byte Test387_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(31)];
    public static byte Test387_var(int index)  => readOnlySpan[(index & Var(10)) << Var(31)];
    public static byte Test388_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(32)];
    public static byte Test388_var(int index)  => readOnlySpan[(index & Var(10)) << Var(32)];
    public static byte Test389_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(33)];
    public static byte Test389_var(int index)  => readOnlySpan[(index & Var(10)) << Var(33)];
    public static byte Test390_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(2147483646)];
    public static byte Test390_var(int index)  => readOnlySpan[(index & Var(10)) << Var(2147483646)];
    public static byte Test391_cns(int index)  => readOnlySpan[(index & Cns(10)) << Cns(2147483647)];
    public static byte Test391_var(int index)  => readOnlySpan[(index & Var(10)) << Var(2147483647)];
    public static byte Test392_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(-2147483648)];
    public static byte Test392_var(int index)  => readOnlySpan[(index & Var(11)) << Var(-2147483648)];
    public static byte Test393_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(-2147483647)];
    public static byte Test393_var(int index)  => readOnlySpan[(index & Var(11)) << Var(-2147483647)];
    public static byte Test394_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(-33)];
    public static byte Test394_var(int index)  => readOnlySpan[(index & Var(11)) << Var(-33)];
    public static byte Test395_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(-32)];
    public static byte Test395_var(int index)  => readOnlySpan[(index & Var(11)) << Var(-32)];
    public static byte Test396_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(-31)];
    public static byte Test396_var(int index)  => readOnlySpan[(index & Var(11)) << Var(-31)];
    public static byte Test397_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(-1)];
    public static byte Test397_var(int index)  => readOnlySpan[(index & Var(11)) << Var(-1)];
    public static byte Test398_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(0)];
    public static byte Test398_var(int index)  => readOnlySpan[(index & Var(11)) << Var(0)];
    public static byte Test399_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(1)];
    public static byte Test399_var(int index)  => readOnlySpan[(index & Var(11)) << Var(1)];
    public static byte Test400_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(2)];
    public static byte Test400_var(int index)  => readOnlySpan[(index & Var(11)) << Var(2)];
    public static byte Test401_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(31)];
    public static byte Test401_var(int index)  => readOnlySpan[(index & Var(11)) << Var(31)];
    public static byte Test402_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(32)];
    public static byte Test402_var(int index)  => readOnlySpan[(index & Var(11)) << Var(32)];
    public static byte Test403_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(33)];
    public static byte Test403_var(int index)  => readOnlySpan[(index & Var(11)) << Var(33)];
    public static byte Test404_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(2147483646)];
    public static byte Test404_var(int index)  => readOnlySpan[(index & Var(11)) << Var(2147483646)];
    public static byte Test405_cns(int index)  => readOnlySpan[(index & Cns(11)) << Cns(2147483647)];
    public static byte Test405_var(int index)  => readOnlySpan[(index & Var(11)) << Var(2147483647)];
    public static byte Test406_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(-2147483648)];
    public static byte Test406_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(-2147483648)];
    public static byte Test407_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(-2147483647)];
    public static byte Test407_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(-2147483647)];
    public static byte Test408_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(-33)];
    public static byte Test408_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(-33)];
    public static byte Test409_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(-32)];
    public static byte Test409_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(-32)];
    public static byte Test410_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(-31)];
    public static byte Test410_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(-31)];
    public static byte Test411_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(-1)];
    public static byte Test411_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(-1)];
    public static byte Test412_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(0)];
    public static byte Test412_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(0)];
    public static byte Test413_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(1)];
    public static byte Test413_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(1)];
    public static byte Test414_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(2)];
    public static byte Test414_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(2)];
    public static byte Test415_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(31)];
    public static byte Test415_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(31)];
    public static byte Test416_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(32)];
    public static byte Test416_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(32)];
    public static byte Test417_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(33)];
    public static byte Test417_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(33)];
    public static byte Test418_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(2147483646)];
    public static byte Test418_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(2147483646)];
    public static byte Test419_cns(int index)  => readOnlySpan[(index & Cns(2147483646)) << Cns(2147483647)];
    public static byte Test419_var(int index)  => readOnlySpan[(index & Var(2147483646)) << Var(2147483647)];
    public static byte Test420_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(-2147483648)];
    public static byte Test420_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(-2147483648)];
    public static byte Test421_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(-2147483647)];
    public static byte Test421_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(-2147483647)];
    public static byte Test422_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(-33)];
    public static byte Test422_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(-33)];
    public static byte Test423_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(-32)];
    public static byte Test423_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(-32)];
    public static byte Test424_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(-31)];
    public static byte Test424_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(-31)];
    public static byte Test425_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(-1)];
    public static byte Test425_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(-1)];
    public static byte Test426_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(0)];
    public static byte Test426_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(0)];
    public static byte Test427_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(1)];
    public static byte Test427_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(1)];
    public static byte Test428_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(2)];
    public static byte Test428_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(2)];
    public static byte Test429_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(31)];
    public static byte Test429_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(31)];
    public static byte Test430_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(32)];
    public static byte Test430_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(32)];
    public static byte Test431_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(33)];
    public static byte Test431_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(33)];
    public static byte Test432_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(2147483646)];
    public static byte Test432_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(2147483646)];
    public static byte Test433_cns(int index)  => readOnlySpan[(index & Cns(2147483647)) << Cns(2147483647)];
    public static byte Test433_var(int index)  => readOnlySpan[(index & Var(2147483647)) << Var(2147483647)];
}
